#include "ListFactory.h"

#include "ListT.h"
#include "Color.h"

std::unique_ptr<List> ListFactory::Create(List::Type type, std::size_t size)
{
	std::unique_ptr<List> list;
	if (type == List::Type::DOUBLE)
	{
		list = std::make_unique<ListT<double>>(type, size, 0.0);
	}
	else if (type == List::Type::UCHAR)
	{
		list = std::make_unique<ListT<unsigned char> >(type, size, 0);
	}
	else if (type == List::Type::UINT8)
	{
		list = std::make_unique<ListT<uint8_t>>(type, size, 0);
	}
	else if (type == List::Type::COLOR)
	{
		list = std::make_unique<ListT<Color>>(type, size, Color());
	}
	return std::move(list);
}